#include <bits/stdc++.h>

using namespace std;

char griglia[3][3];

int X = 0;
int O = 0;

bool tris(char mark) {
    int c, i, j;
    
    // diagonals
    for(c = i = 0; i < 3; i++) if(griglia[i][i] == mark) c++;
    if(c == 3) return true;
    for(c = i = 0; i < 3; i++) if(griglia[i][2-i] == mark) c++;
    if(c == 3) return true;

    for(i = 0; i < 3; i++) {
        // rows
        for(c = j = 0; j < 3; j++) if(griglia[i][j] == mark) c++;
        if(c == 3) return true;
        
        // columns
        for(c = j = 0; j < 3; j++) if(griglia[j][i] == mark) c++;
        if(c == 3) return true;
    }

    return false;
}

int vincente() {
    // base cases
    if(tris('X')) return 1;
    if(tris('O') || X + O == 9) return 0;
    
    if(X <= O) {
        // is there a winning choice for X?
        for(int i = 0; i < 3; i++) {
            for(int j = 0; j < 3; j++) {
                if(griglia[i][j] != '.') continue;
                griglia[i][j] = 'X';
                X++;
                int res = vincente();
                griglia[i][j] = '.';
                X--;
                if(res == 1) return 1;
            }
        }
        return 0;
    }
    
    // do all choices for O still lead to a win for X?
    for(int i = 0; i < 3; i++) {
        for(int j = 0; j < 3; j++) {
            if(griglia[i][j] != '.') continue;
            griglia[i][j] = 'O';
            O++;
            int res = vincente();
            griglia[i][j] = '.';
            O--;
            if(res == 0) return 0;
        }
    }
    return 1;
}



int main() {
    FILE *fr, *fw;
    int r, c;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    for (r=0; r<3; r++) {
        for (c=0; c<3; c++) {
            griglia[r][c] = fgetc(fr);
            if(griglia[r][c] == 'X') X++;
            else if(griglia[r][c] == 'O') O++;
        }
        fgetc(fr);
    }

    fprintf(fw, "%d\n", vincente());
    fclose(fr);
    fclose(fw);
    return 0;
}
