#include <bits/stdc++.h>

using namespace std;

#define MAXN 9

int c[MAXN];    // ciphers in the input
int N;
int target;     // target sum

vector<int> sol;    // (partial) solution

// utility function to print out the solution (note that the last element is not printed because is a fake one)
void print(ofstream& out) {
    for(int i = 0; i < sol.size() - 1; i++) out << (sol[i]+1) << " ";
    out << endl;
}

void solve(ofstream& out, int i = 0, int s = 0) {
    // is this a new solution?
    if(i == N) { 
        if(s == target) print(out); 
        return;
    }
    
    // already exceeded the target sum
    if(s >= target) return;
    
    // try to add a plus in each possible position, and solve the corresponding subproblem
    int left = 0;
    for(int j = i; j < N; j++) {
        left = left * 10 + c[j];
        sol.push_back(j);
        solve(out, j + 1, s + left);
        sol.pop_back(); 
    }
}

int main() {
    ifstream in("input.txt");
    ofstream out("output.txt");
    
    in >> N;
    for(int i = 0; i < N; i++) in >> c[i];
    in >> target;
    
    solve(out);
    
    return 0;
}
