#include <stdio.h>
#include <assert.h>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define MAXN 100000

int trend(int N, int G[]) {
    unordered_set<int> res;
    unordered_map<int,int> f;   // every number being a mode at some time
    int max = 0;        // current max frequency
    for(int i = 0; i < N; i++) {
        if(++f[G[i]] >= max) {  // it's mode!
            max = f[G[i]];
            res.insert(G[i]);
        }
    }
    return res.size();
}


int G[MAXN];

int main() {
    FILE *fr, *fw;
    int N, i;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    fscanf(fr, "%d", &N);
    for(i=0; i<N; i++)
        fscanf(fr, "%d", &G[i]);

    fprintf(fw, "%d\n", trend(N, G));
    fclose(fr);
    fclose(fw);
    return 0;
}
